PROGRAM Example3;
{

        This shows an example of the Checkerd Board routines

}
{}
{$DEFINE USEDOSMEM }      { Use DOS to allocate memory }

{$IFDEF USEDOSMEM}
   {$M 16384,0,5000}      { now use MEMALLOC/DALLOC instead of GETMEM/FREEMEM}
{$ELSE}
   {$M 65520,0,655360}    { just use GETMEM/FREEMEM }
{$ENDIF}

USES CRT,SuperFX;
{
                                Main Program
}
VAR i,r,g,b : byte;

BEGIN
     InitVgaMode;
     BlackPal;                          { set palette to black }
     { Create the copper bars, colors 1-64 are used for checkerd board       }
     r:=0; g:=0; b:=0;
     for i:=65 to 185 do begin
         port[$03c8]:=i;
         port[$03c9]:=r;
         port[$03c9]:=g;
         port[$03c9]:=b;
         if r<63 then inc(r) else begin
            r:=63;
            if g<63 then inc(g) else begin
               g:=63;
               if b<63 then inc(b) else b:=63;
            end;
         end;
     end;

     InitBoard(63,63,63,00,2,45);       { create the checkerd board }

     { Initialise the copper bars }
     CopperTop:=65;
     Copperbottom:=185;
     ForceHight:=true;
     CopperHight:=1;
     UseCopper:=true;
     UseLayer:=false;
     InitCopper;

     REPEAT
         CopperSkyDown;           { draw Copper Bars }
         UpdateBoard;           { Draw the checkerd Board }

         Retrace;               { wait for vertical retrace }
         ShowBitmap;            { show the virtual page }

     UNTIL key[esckey];

     TextMode(C80);
End.
