{
        FX Creator
        Coding by P.Bestebroer
        Copyright 1996,1997 by Just4Fun productions

        This program will create a base source code for using with the
        superFX engine.
        The idea is very simple, yet effective!

        E-Mail   : rpb@zeelandnet.nl
        Internet : http://people.zeelandnet.nl/rpb/pindex.html

        Mail     : Just4Fun Productions
                   A.Edenlaan 28
                   4463 JC GOES
                   Holland


        Revision History

        0.1 - First release.

}
{$R-} {No range checking}
{$S-} {No stack overflow checking}
{$I-} {No IO checking}
{$Q-} {No overflow checking}
{$G+} {Enable 286 instructions}

USES CRT,DOS;

CONST Version = $001;

VAR  Outfile : text;
     zin     : string;

     progname : string;
     dosmem   : string;
     dfpname  : string;
     copyname : string;
     email    : string;
     http     : string;
{}
{
        Ask for input of user

        Expects: Question to ask
        Returns: the answer
}
FUNCTION Ask(quest:string;def:string):string;
VAR answ : string;
BEGIN
 write(quest+'['+def+']');
 readln(answ);
 if answ='' then ask:=def else ask:=answ;
END;
{}
BEGIN
 {
   Show the title
 }
 textcolor(7); textbackground(0); clrscr;
 write('FX Creator ');
   write(version div 256,'.',version and $ff);
   writeln('  Copyright 1996,1997 by Just4Fun Productions');
 writeln('');
 {
    See for defaults values
 }
 assign(outfile,'creator.def');
  {$I-}
    reset(outfile);
  {$I+}
 if ioresult=0 then begin
      readln(outfile,progname);
      readln(outfile,dosmem);
      readln(outfile,dfpname);
      readln(outfile,copyname);
      readln(outfile,email);
      readln(outfile,http);
      close(outfile);
 end else begin
      progname:='';
      dosmem:='';
      dfpname:='';
      copyname:='';
      email:='';
      http:='';
 end;

 progname:=ask('Program name        :',progname);
 dosmem  :=ask('Use DOS memory [y/n] ',dosmem);
 dfpname :=ask('DFP file to use     :',dfpname);
 copyname:=ask('Copyright by        :',copyname);
 email   :=ask('E-Mail adress       :',email);
 http    :=ask('Http adress         :',http);

 assign(outfile,progname+'.pas'); rewrite(outfile);
 writeln(outfile,'PROGRAM '+progname+';');
 writeln(outfile,'{');
 writeln(outfile,'          '+progname);
 writeln(outfile,'          Copyright by '+copyname);
 writeln(outfile,'          ');
 if email<>'' then writeln(outfile,'          E-Mail   : '+email);
 if http<>'' then writeln(outfile,'          Internet : '+http);
 writeln(outfile,' ');
 writeln(outfile,'          Revision history');
 writeln(outfile,'          ');
 writeln(outfile,'          0.1 - First release');
 writeln(outfile,'}');
 writeln(outfile,'');
 writeln(outfile,'{$R-} {No range checking}');
 writeln(outfile,'{$S-} {No stack overflow checking}');
 writeln(outfile,'{$I-} {No IO checking}');
 writeln(outfile,'{$Q-} {No overflow checking}');
 writeln(outfile,'{$G+} {Enable 286 instructions}');
 writeln(outfile,' ');

 if (dosmem='y') or (dosmem='Y') then begin
    writeln(outfile,'{$DEFINE USEDOSMEM}   { use dos to allocate memory }');
 end else begin
    writeln(outfile,'{.$DEFINE USEDOSMEM}');
 end;
 writeln(outfile,'{$IFDEF USEDOSMEM}');
 writeln(outfile,'  {$M 16384,0,5000}     { Minimum of HEAP memory needed }');
 writeln(outfile,'{$ELSE}');
 writeln(outfile,'  {$M 65520,0,655360}   { Maximum of HEAP memory needed }');
 writeln(outfile,'{$ENDIF}');
 writeln(outfile,' ');
 writeln(outfile,'USES CRT,DOS,SUPERFX,SFX_VARS;');
 writeln(outfile,' ');
 writeln(outfile,'CONST GameVersion = $001;            { The version of the game }');
 writeln(outfile,'      QuitGame    : boolean = false; { for quiting! }');
 writeln(outfile,'{}');
 writeln(outfile,'BEGIN');
 writeln(outfile,' { First see if the datafile is present }');
 writeln(outfile,' IF not UseFile(',dfpname,') then begin');
 writeln(outfile,'   halt_Error:=''ERROR - File not found:',dfpname,';   { oops, not found!   }');
 writeln(outfile,'   halt;                                               { just halt          }');
 writeln(outfile,' END;');
 writeln(outfile,'');
 writeln(outfile,' { ');
 writeln(outfile,'     Now initialise the VGA mode ');
 writeln(outfile,' } ');
 writeln(outfile,' InitVGAmode;');
 writeln(outfile,' { ');
 writeln(outfile,'     Main loop starts here ');
 writeln(outfile,' } ');
 writeln(outfile,' REPEAT ');
 writeln(outfile,'');
 writeln(outfile,'    UpdateMap;  { update the background map }');
 writeln(outfile,'');
 writeln(outfile,'    retrace;    { wait for vertical retrace }');
 writeln(outfile,'    ShowBitmap  { show the virtual page ');
 writeln(outfile,'');
 writeln(outfile,' UNTIL (QuitGame) or (key[esckey]); ');
 writeln(outfile,' ');
 writeln(outfile,'END.');
 close(outfile);
 writeln('File: ['+progname+'.pas] created');

 {

    Save default values

 }
 assign(outfile,'creator.def'); rewrite(outfile);
      writeln(outfile,progname);
      writeln(outfile,dosmem);
      writeln(outfile,dfpname);
      writeln(outfile,copyname);
      writeln(outfile,email);
      writeln(outfile,http);
 close(outfile);

END.
