UNIT Param_ch; {THIS IS FREEWARE, and coded by Pascal Bestebroer}

INTERFACE



const  Case_Checking :boolean = false;        {Check for Upper/Lower case ?}

PROCEDURE Up_case(var name:string);
FUNCTION show_params:integer;
FUNCTION see_for(name:string):boolean;
FUNCTION Pget_nr(name:string;num:integer):longint;
FUNCTION Pget_string(name:string;num:integer):string;

IMPLEMENTATION

uses crt;
var i :integer;
    zin :string;

{}
PROCEDURE Up_case(var name:string);
{Converts a string to all upper-case chars}
var  i    : integer;  {Counter}
begin
 for i:=1 to length(name) do name[i]:=upcase(name[i]);
end;
{}
FUNCTION show_params:integer;
{Shows all paramaters, and returns the amount of parameters found}
var  i :integer;
begin
  show_params:=paramcount;
  writeln('Parameter_list:');
  for i:=1 to paramcount do begin
      writeln(paramstr(i));
  end;
end;
{}
FUNCTION see_for(name:string):boolean;
{See if a specified parameter is given}

var i,                            {Counter}
    x               : integer;    {Give x position of found word}
    zin             : string;     {To store the current paramstr into}
begin
 see_for:=false;
 if not case_checking then up_case(name);
 for i:=1 to paramcount do begin
    zin:=paramstr(i);
    if not case_checking then up_case(zin);
    x:=pos(name,zin);
    if x>0 then begin
       see_for:=true;
    end;
 end;
end;
{}
FUNCTION Pget_nr(name:string;num:integer):longint;
{Searches the parameters for one containing [NAME] and then gives back the
 [num]th value following that paramater. If no paramater is found, or a
 string is found, Pget_Nr will return a 0}

var  x,x2,                            {used with the POS command}
     k,                               {Use for the VAL command}
     i,j   : integer;                 {Counters}
     zin,zin2 : string;                  {For storing the paramstr}
     done  : boolean;                 {Done with the routine?}
     found : array[1..10] of string;  {To store all values given to a param}

begin
 Pget_nr:=0;
 if not case_checking then up_case(name);
 i:=1;
 repeat
   zin:=paramstr(i);
   if not case_checking then up_case(zin);
   x:=pos(name,zin);
   if x>0 then begin
     x:=x+length(name)-1;
     zin:=copy(zin,x+1,length(zin)-x);
     x2:=1;
     x:=0;
     zin2:=zin;
     j:=0;
     repeat
        x2:=x2+x;
        x:=pos(',',copy(zin,x2,length(zin)-x2));                 {Search for next , }
        if x=0 then x:=pos(' ',zin);     {no , found so search for a space}
        if x=0 then x:=length(zin);      {no space found, just take it all!}
        inc(j);
     until (j>=num) or (x2+x>length(paramstr(i)));
     if j=num then begin
        done:=true;
        zin:=copy(zin,x2,x);
        val(zin,x,k);                {Get the value}
        Pget_nr:=x;
     end;
   end;
   inc(i);
 until (i>paramcount) or (done);
end;
{}
FUNCTION Pget_string(name:string;num:integer):string;
{Searches the parameters for one containing [NAME] and then gives back the
 [num]th string following that paramater. If no paramater is found,
 Pget_String will return an empty string}

var  x,x2,                            {used with the POS command}
     k,                               {Use for the VAL command}
     i,j   : integer;                 {Counters}
     zin,zin2 : string;                  {For storing the paramstr}
     done  : boolean;                 {Done with the routine?}
     found : array[1..10] of string;  {To store all values given to a param}

begin
 Pget_string:='';
 if not case_checking then up_case(name);
 i:=1;
 done:=false;
 repeat
   zin:=paramstr(i);
   if not case_checking then up_case(zin);
   x:=pos(name,zin);
   if x>0 then begin
     x:=x+length(name)-1;
     zin:=copy(zin,x+1,length(zin)-x);
     x2:=1;
     x:=0;
     zin2:=zin;
     j:=0;
     repeat
        x2:=x2+x;
        x:=pos(',',copy(zin,x2,length(zin)-x2));                 {Search for next , }
        if x=0 then x:=pos(' ',zin);     {no , found so search for a space}
        if x=0 then x:=length(zin)+1;      {no space found, just take it all!}
        inc(j);
     until (j=num) or (x2+x>length(paramstr(i)));
{     if j=num then begin}
        done:=true;
        zin:=copy(zin,x2,x-1);
        Pget_string:=zin;
{     end;}
   end;
   inc(i);
 until (i>paramcount) or (done);
end;
{}

begin
end.


